from otrs_somconnexio.otrs_models.configurations.querys.we_call_you import (
    WeCallYouCATConfiguration,
    WeCallYouESConfiguration,
)
from otrs_somconnexio.otrs_models.ticket_types.base_customer_ticket import BaseCustomerTicket


class WeCallYouTicket(BaseCustomerTicket):
    def __init__(self, username, customer_code, fields_dict, *args):
        super(WeCallYouTicket, self).__init__(
            username, customer_code, fields_dict, *args
        )
        self.configuration = (
            WeCallYouCATConfiguration
            if fields_dict["language"] == "ca_ES"
            else WeCallYouESConfiguration
        )

    def _get_activity_id(self):
        return self.configuration.activity_id

    def _get_process_id(self):
        return self.configuration.process_id

    def _get_queue_id(self):
        return self.configuration.queue_id

    def _get_subject(self):
        return self.configuration.subject

    def _get_dynamic_fields(self):
        return {
            "personaContacte": self.fields["name"],
            "horariTrucada": self.fields["schedule"],
            "telefonContacte": self.fields["phone"],
            "motiuTrucada": self.fields["reason"],
        }
